'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ArcherContainer = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _resizeObserverPolyfill = require('resize-observer-polyfill');

var _resizeObserverPolyfill2 = _interopRequireDefault(_resizeObserverPolyfill);

var _Point = require('./Point');

var _Point2 = _interopRequireDefault(_Point);

var _SvgArrow = require('./SvgArrow');

var _SvgArrow2 = _interopRequireDefault(_SvgArrow);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var style = {
  position: 'absolute',
  width: '100%',
  height: '100%',
  top: 0,
  left: 0
};

function rectToPoint(rect) {
  return new _Point2.default(rect.left, rect.top);
}

function computeCoordinatesFromAnchorPosition(anchorPosition, rect) {
  switch (anchorPosition) {
    case 'top':
      return rectToPoint(rect).add(new _Point2.default(rect.width / 2, 0));
    case 'bottom':
      return rectToPoint(rect).add(new _Point2.default(rect.width / 2, rect.height));
    case 'left':
      return rectToPoint(rect).add(new _Point2.default(0, rect.height / 2));
    case 'right':
      return rectToPoint(rect).add(new _Point2.default(rect.width, rect.height / 2));
    default:
      return new _Point2.default(0, 0);
  }
}

var ArcherContainer = exports.ArcherContainer = function (_React$Component) {
  _inherits(ArcherContainer, _React$Component);

  function ArcherContainer(props) {
    _classCallCheck(this, ArcherContainer);

    var _this = _possibleConstructorReturn(this, (ArcherContainer.__proto__ || Object.getPrototypeOf(ArcherContainer)).call(this, props));

    _this.registerTransition = _this.registerTransition.bind(_this);
    _this.registerChild = _this.registerChild.bind(_this);
    _this.storeParent = _this.storeParent.bind(_this);
    _this.refreshScreen = _this.refreshScreen.bind(_this);
    _this.state = {
      refs: {},
      fromTo: []
    };
    return _this;
  }

  _createClass(ArcherContainer, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      window.addEventListener('resize', this.refreshScreen);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this.refreshScreen);
    }
  }, {
    key: 'refreshScreen',
    value: function refreshScreen() {
      this.setState(_extends({}, this.state));
    }
  }, {
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        registerTransition: this.registerTransition,
        registerChild: this.registerChild
      };
    }
  }, {
    key: 'storeParent',
    value: function storeParent(ref) {
      if (this.state.parent) {
        return;
      }
      this.setState(function (currentState) {
        return _extends({}, currentState, { parent: ref });
      });
    }
  }, {
    key: 'getRectFromRef',
    value: function getRectFromRef(ref) {
      if (!ref) {
        return new _Point2.default(0, 0);
      }
      return ref.getBoundingClientRect();
    }
  }, {
    key: 'getParentCoordinates',
    value: function getParentCoordinates() {
      var rectp = this.getRectFromRef(this.state.parent);
      return rectToPoint(rectp);
    }
  }, {
    key: 'getPointCoordinatesFromAnchorPosition',
    value: function getPointCoordinatesFromAnchorPosition(position, index, parentCoordinates) {
      var rect = this.getRectFromRef(this.state.refs[index]);
      var absolutePosition = computeCoordinatesFromAnchorPosition(position, rect);

      return absolutePosition.substract(parentCoordinates);
    }
  }, {
    key: 'registerTransition',
    value: function registerTransition(fromElement, relation) {
      var _this2 = this;

      var fromTo = [].concat(_toConsumableArray(this.state.fromTo));
      var newFromTo = _extends({}, relation, { from: _extends({}, relation.from, { id: fromElement }) });
      fromTo.push(newFromTo);
      this.setState(function (currentState) {
        return _extends({}, _this2.currentState, { fromTo: [].concat(_toConsumableArray(currentState.fromTo), _toConsumableArray(fromTo)) });
      });
    }
  }, {
    key: 'registerChild',
    value: function registerChild(id) {
      var _this3 = this;

      return function (ref) {
        if (!_this3.state.refs[id]) {
          var ro = new _resizeObserverPolyfill2.default(function () {
            _this3.refreshScreen();
          });
          ro.observe(ref);
          _this3.setState(function (currentState) {
            return _extends({}, _this3.currentState, { refs: _extends({}, currentState.refs, _defineProperty({}, id, ref)) });
          });
        }
      };
    }
  }, {
    key: 'computeArrows',
    value: function computeArrows() {
      var _this4 = this;

      var parentCoordinates = this.getParentCoordinates();
      return this.state.fromTo.map(function (sd) {
        var startingAnchor = sd.from.anchor;
        var startingPoint = _this4.getPointCoordinatesFromAnchorPosition(sd.from.anchor, sd.from.id, parentCoordinates);
        var endingAnchor = sd.to.anchor;
        var endingPoint = _this4.getPointCoordinatesFromAnchorPosition(sd.to.anchor, sd.to.id, parentCoordinates);
        return _react2.default.createElement(_SvgArrow2.default, {
          key: JSON.stringify(sd),
          startingPoint: startingPoint,
          startingAnchor: startingAnchor,
          endingPoint: endingPoint,
          endingAnchor: endingAnchor,
          strokeColor: _this4.props.strokeColor,
          arrowLength: _this4.props.arrowLength
        });
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var SvgArrows = this.computeArrows();
      var arrowPath = 'M0,0 L0,' + this.props.arrowThickness + ' L' + (this.props.arrowLength - 1) + ',' + this.props.arrowThickness / 2 + ' z';

      return _react2.default.createElement(
        _react2.default.Fragment,
        null,
        _react2.default.createElement(
          'svg',
          { style: style },
          _react2.default.createElement(
            'defs',
            null,
            _react2.default.createElement(
              'marker',
              {
                id: 'arrow',
                markerWidth: this.props.arrowLength,
                markerHeight: this.props.arrowThickness,
                refX: '0',
                refY: this.props.arrowThickness / 2,
                orient: 'auto',
                markerUnits: 'strokeWidth'
              },
              _react2.default.createElement('path', {
                d: arrowPath,
                fill: this.props.strokeColor })
            )
          ),
          SvgArrows
        ),
        _react2.default.createElement(
          'div',
          { ref: this.storeParent, style: style },
          this.props.children
        )
      );
    }
  }]);

  return ArcherContainer;
}(_react2.default.Component);

ArcherContainer.propTypes = {
  arrowLength: _propTypes2.default.number,
  arrowThickness: _propTypes2.default.number,
  strokeColor: _propTypes2.default.string,
  children: _propTypes2.default.node
};

ArcherContainer.defaultProps = {
  arrowLength: 10,
  arrowThickness: 6,
  strokeColor: '#f00'
};

ArcherContainer.childContextTypes = {
  registerChild: _propTypes2.default.func,
  registerTransition: _propTypes2.default.func
};

exports.default = ArcherContainer;